
(*
Esercizio 2 di Esercizidel22-5-17
Si consideri la definizione di coppia in Pair.Java, per coppie non modificabili. 
Si chiede di:
 (a) Introdurre in Ocaml, un API per tali coppie;
 (b) Definire un ADT, ImPairADT.ml, per tale API;
 (c) Fornire AF e I  della rappresentazione scelta;
 (d) Fornire un caso di uso di PairADT.ml;
 (e) Provare la correttezza di I.

 public class Pair <A,B> {
   public final A left;
   public final B right;
   public Pair (A x, B y) {
      left = x;
      right = y;
   }
}
*)

(* (a) *)
module type COPPIA =
sig
	type ('a,'b) coppia
	val make: 'a * 'b -> ('a,'b) coppia
    val getLeft: ('a,'b) coppia -> 'a
    val getRight: ('a,'b) coppia -> 'b
end;;


(* (b) *)
module ImPairADT =
(struct
	type ('a,'b) coppia = 'a * 'b
	let make(x,y) = (x,y)
    let getLeft(x,y) = x
    let getRight(x,y) = y
end:COPPIA);;

(* (c)
Sia [(Ta,Tb)ImPairADT.coppia]={(x,y) | x\inTa, y\inTb, Ta\in['a], Tb\in['b]}, l'insieme 
dei valori astratti definiti da (Ta,Tb)ImPairADT.coppia. Allora, per ogni valore concreto 
c esprimibile con lo stato concreto definito dalla rappresentazione:
AF(c) = (match c with (left,right) -> left, match c with (left,right) -> right)
I(c) = true
*)

(* (d) *)
let (myPlayCard:(int,string)ImPairADT.coppia) = ImPairADT.make(3,"fiori")
	and
	simply = ImPairADT.make(3,"fiori")
in "il valore della carta e' " ^ string_of_int(ImPairADT.getLeft(simply));;
/*
# let (myPlayCard:(int,string)ImPairADT.coppia) = ImPairADT.make(3,"fiori")
        and
        simply = ImPairADT.make(3,"fiori")
  in "il valore della carta e' " ^ string_of_int(ImPairADT.getLeft(simply));;    
Warning 26: unused variable myPlayCard.
- : string = "il valore della carta e' 3"
# */

/* (e)
I(c) e' true quindi e' sempre verificato e la correttezza e' banalmente provata
*/

