
(*
Esercizio 4 di Esercizidel22-5-17
Si discuta in OCaml un'estensione del tipo coppia con gli additionals in analogia a quanto
fatto in esercizio3 in java.
*)

(* (a) 
 In Ocaml non possiamo estendere a la Java: Estendere in OCaml significa definire un nuovo
 tipo astratto in tutto e per tutto indipendente da quello precedente e i cui valori sono
 inconfrontabili con quelli del tipo originale.
*)
module type COPPIA =
sig
	type ('a,'b) coppia
	val make: 'a * 'b -> ('a,'b) coppia
    val getLeft: ('a,'b) coppia -> 'a
    val getRight: ('a,'b) coppia -> 'b
    (* 
       clone e equals non hanno senso perche' solo valori solo IMMUTABLE 
       Ocaml ha gia' = (identita' di valore) e == (identit\`a di rappresentazione) 
    *)
    (* 
    	elements per valori a componenti di tipo inconfrontabile non puo' essere 
    	espressa con polimorfismo generico ricorrendo ad 'a list
    *)
    (* 
    	Potremmo aggiungere:
    	val toString: ('a,'b) coppia -> string
    	ma non possiamo definirla in Ocaml
    *)
end;;


(* (b) *)
module ImPairADTX =
(struct
	type ('a,'b) coppia = 'a * 'b
	let make(x,y) = (x,y)
    let getLeft(x,y) = x
    let getRight(x,y) = y
    (* 
    let toString(x,y) = "("^toString(x)^","^toString(y)^")"
    non puo' essere definita senza delay-binding 
    *)
    
end:COPPIA);;

 

