import java.util.*;
import java.io.*;

/*
 Esercizio3 di Esercizidel22-5-17
 (a)
 Si estenda la classa ImPairADT<A,B> (di esercizio 2 in AltriEsercizi6.pdf) con
 gli additionals (equals, clone, toString, elements)

 public class ImPairADT <A,B> {
    private final A left;//da nascondere
    private final B right;//da nascondere
    public ImPairADT (A x, B y) {
        left = x;
        right = y;
    }
    public A getLeft(){//da aggiungere per uso effettivo
        return left;
    }
    public B getRight(){//da aggiungere per uso effettivo
        return right;
    }
}
 
 (b)
 Si presenti un caso di uso con tutte e quattro le operazioni additionals

 (c)
 Si discuta se e come devono essere estese le Funzioni AF ed I in conseguenza 
 di tale estensione
*/

public class ImPairADTX<A,B> extends ImPairADT<A,B> implements Cloneable{
	public ImPairADTX (A x, B y) {
		super(x,y);
	}
	//nessuna necessit\`a di ridefinire getLeft, e getRight
	public boolean equals(Object o){
		ImPairADTX<?,?> myo;
		try {
			myo = (ImPairADTX<?,?>)o;
		}
		catch (Exception e) {
			return false;
		}
		return getLeft().equals(myo.getLeft()) && getRight().equals(myo.getRight());
	}
	public ImPairADTX<A,B> clone() throws CloneNotSupportedException{
		return new ImPairADTX<A,B>(getLeft(),getRight()) ;
	}
	public String toString(){
		String ret = "("+getLeft().toString()+","+getRight().toString()+")";
		return ret;
	}
	//nessuna definizione per elements: ImPairADT<A,B> non \`e un valore strutturato.
    public LinkedList <Object> elements(){
        LinkedList<Object> ret = new LinkedList<Object>();
        ret.add(getLeft());
        ret.add(getRight());
        return ret;
    }
}

/* (b) in the enclosed file named mainIPAX*/

/* (c)
 L'estensione non richiede alcuna estensione di stato concreto. Quindi AF ed I di ogni 
 oggetto sono quelli del super. 
 Poich\`e ImPairADT<A,B> \`e un tipo astratto che soddisfa le 3 propriet\`a (stato 
 privato, segnatura pubblica, non esposizione stato) niente deve essere provato sulla
 veridicit\`a dell'invariante sia nel vecchio che nel nuovo codice.
*/


